/*	--------------------------------------------------------------------------------------

	Copyright  1990-1991, Apple Computer, Inc, All Rights Reserved.
	
	File:		ResourceTypes.h
		
	Author:		John Farmer
	
	Contains:	Constants for several basic resource types.
	
	Revisions: (most recent first):
	
		ID		Date		Description
		
		<1>		11/29/90	John Farmer - Create file and it's original contents.
														
	-----------------------------------------------------------------------------------  */


#ifndef			__ResourceTypes__
#define			__ResourceTypes__


// Constants
	
	
	#define		kStringResourceType				'STR '
	#define		kStringListResourceType			'STR#'
	#define		kItlbResourceType				'itlb'
	#define		kDriverResourceType				'DRVR'
	#define		kFontResourceType				'FONT'
	

#endif			__ResourceTypes__